// following is an example of general pattern that handles, enter, update, and exit
// 5:13:14 first part (selectAll) selects empty elements because there are no circle) 
// .data return data join it self then you enter and append


import { scaleOrdinal } from 'd3'; 


const colorScale = scaleOrdinal ()
	.domain(['apple', 'lemon'])
	.range(['#c11d1d', '#eae600']);

const radiusScale = scaleOrdinal ()
	.domain(['apple', 'lemon'])
	.range([50, 30]);

const xPosition = (d, i) => i*120 + 60;


export const fruitBowl = (selection, props) => {
  const { fruits, height } = props;
  const circles = selection.selectAll('circle')
  	.data(fruits, d => d.id);
  
  
  // enter, attr, and attr, is the enter selection hen merger is going toward 
  // merge is being called from the enter selection
  // merge returns the update and enter selection
  // merge lines are runnning for both enter update selection
  // enter selection only work when the element is being added for the first time
  circles 
    .enter().append('circle')
  		.attr('cx', xPosition)
      .attr('cy', height/3)
      .attr('r', 0)
  	.merge(circles)
      .attr('fill', d => colorScale(d.type)) 
  	.transition().duration(1000)
      .attr('cx', (d, i) => i*120 + 60)
  		.attr('r', d => radiusScale(d.type));

  // exit selects the different of fruits and circle 
//svg.selectAll('circle').data(fruits)
//	.exit()
//		.attr('fill', 'black')
  
  
  circles.exit()
  	.transition().duration(1000)
  		.attr('r',0)  
    .remove();
  
  
  
}